import Styles from "@/constants/Styles";
import { apiGetProjectOne } from "@/lib/api";
import { useAuthSession } from "@/providers/AuthProvider";
import { useTheme } from "@/providers/ThemeProvider";
import { useLocalSearchParams } from "expo-router";
import { useEffect, useState } from "react";
import { View } from "react-native";
import { useSelector } from "react-redux";
import Text from "../Text";
import TextExpandable from "../textExpandable";

export default function SectionReportProject({ refreshing }: { refreshing?: boolean }) {
   const { colors } = useTheme();
   const update = useSelector((state: any) => state.projectUpdate)
   const { token, decryptToken } = useAuthSession();
   const { id } = useLocalSearchParams<{ id: string }>();
   const [data, setData] = useState("");

   async function handleLoad() {
      try {
         const hasil = await decryptToken(String(token?.current));
         const response = await apiGetProjectOne({
            user: hasil,
            cat: "data",
            id: id,
         });
         setData(response.data.report);
      } catch (error) {
         console.error(error);
      }
   }

   useEffect(() => {
      handleLoad();
   }, [update.report]);

   useEffect(() => {
      if (refreshing)
         handleLoad();
   }, [refreshing]);

   return (
      <>
         {
            data != "" && data != null &&
            <View style={[Styles.mb15, Styles.mt10]}>
               <Text style={[Styles.textDefaultSemiBold, Styles.mv05]}>
                  Laporan Kegiatan
               </Text>
               <View style={[Styles.wrapPaper, { backgroundColor: colors.card, borderColor: colors.background }]}>
                  <TextExpandable content={data} maxLines={2} />
               </View>
            </View>
         }
      </>
   );
}
